from .const import CONF_CALLBACK_URL_OVERRIDE as CONF_CALLBACK_URL_OVERRIDE, CONF_LISTEN_PORT as CONF_LISTEN_PORT, CONF_POLL_AVAILABILITY as CONF_POLL_AVAILABILITY, DEFAULT_NAME as DEFAULT_NAME, DOMAIN as DOMAIN
from .data import get_domain_data as get_domain_data
from collections.abc import Callable as Callable
from homeassistant import config_entries as config_entries
from homeassistant.components import ssdp as ssdp
from homeassistant.const import CONF_DEVICE_ID as CONF_DEVICE_ID, CONF_HOST as CONF_HOST, CONF_NAME as CONF_NAME, CONF_TYPE as CONF_TYPE, CONF_URL as CONF_URL
from homeassistant.core import callback as callback
from homeassistant.data_entry_flow import FlowResult as FlowResult
from homeassistant.exceptions import IntegrationError as IntegrationError
from homeassistant.helpers.typing import DiscoveryInfoType as DiscoveryInfoType
from typing import Any, Mapping, Optional

LOGGER: Any
FlowInput = Optional[Mapping[str, Any]]

class ConnectError(IntegrationError): ...

class DlnaDmrFlowHandler(config_entries.ConfigFlow):
    VERSION: int
    _discoveries: Any
    _location: Any
    _udn: Any
    _device_type: Any
    _name: Any
    _options: Any
    def __init__(self) -> None: ...
    @staticmethod
    def async_get_options_flow(config_entry: config_entries.ConfigEntry) -> config_entries.OptionsFlow: ...
    async def async_step_user(self, user_input: FlowInput = ...) -> FlowResult: ...
    async def async_step_manual(self, user_input: FlowInput = ...) -> FlowResult: ...
    async def async_step_import(self, import_data: FlowInput = ...) -> FlowResult: ...
    async def async_step_import_turn_on(self, user_input: FlowInput = ...) -> FlowResult: ...
    async def async_step_ssdp(self, discovery_info: DiscoveryInfoType) -> FlowResult: ...
    async def async_step_unignore(self, user_input: Mapping[str, Any]) -> FlowResult: ...
    async def async_step_confirm(self, user_input: FlowInput = ...) -> FlowResult: ...
    async def _async_connect(self) -> None: ...
    def _create_entry(self) -> FlowResult: ...
    async def _async_set_info_from_discovery(self, discovery_info: Mapping[str, Any], abort_if_configured: bool = ...) -> None: ...
    async def _async_get_discoveries(self) -> list[Mapping[str, Any]]: ...

class DlnaDmrOptionsFlowHandler(config_entries.OptionsFlow):
    config_entry: Any
    def __init__(self, config_entry: config_entries.ConfigEntry) -> None: ...
    async def async_step_init(self, user_input: Union[dict[str, Any], None] = ...) -> FlowResult: ...

def _is_ignored_device(discovery_info: Mapping[str, Any]) -> bool: ...
